% Coloreado de grafos

%por ejemplo:
%
% coloreado(grafo([v(a),v(b),v(c),v(d)],[a(a,b),a(a,c),a(a,d),a(b,d),a(c,d)]),[],[r,v,a],X).
%

grafo([v(a),v(b),v(c),v(d)],[a(a,b),a(a,c),a(a,d),a(b,d),a(c,d)]).

% coloreado(grafo,[],lista_colores,resultado)

coloreado(grafo([],_),C,_,C).
coloreado(grafo([V|LV],A),C,LC,R)<- color(V,CV,LC) & compatible(CV,C,A) & coloreado(grafo(LV,A),[CV|C],LC,R).


color(v(X),c(X,C),[C|_]).
color(X,Y,[_|L])<- color(X,Y,L).

compatible(_,[],_).
compatible(_,_,[]).
compatible(C,[C1|LC],LA)<-compatible_arcos(C,C1,LA) & compatible(C,LC,LA).

compatible_arcos(c(A1,C),c(A2,C),LA)<- ~member(a(A1,A2),LA) & ~member(a(A2,A1),LA).
compatible_arcos(c(A1,C1),c(A2,C2),_)<-C1\=C2.

member(X,[X|_]).
member(X,[_|Y]) <- member(X,Y).
